#include "FlashDataStorege.h"
#include "fds.h"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"


/* RECORD_KEY
	 Record keys should be in the range 0x0001 - 0xBFFF. 
   The value 0x0000 is reserved by the system. 
	 The values from 0xC000 to 0xFFFF are reserved for use by the Peer Manager module 
	 and can only be used in applications that do not include Peer Manager.
	 
	 //FILE_ID
	 File IDs should be in the range 0x0000 - 0xBFFF.
	 The value 0xFFFF is used by the system. 
	 The values from 0xC000 to 0xFFFE are reserved for use by the Peer Manager module 
	 and can only be used in applications that do not include Peer Manager.
*/

int hr_key = 1;
int calories_key = 1;
extern uint32_t UTC_data; //amy-debug, add UTC data
float Calories_sum = 0 ;

int get_latest_calories(void)
{
	return Calories_sum;
}

void SaveImportantData(void)
{
		static int32_t Key[KEY_LENGTH];
		
		Key[0] = hr_key;
		Key[1] = calories_key;

		Update_A_Record(KEY_FILEID, KEY_RECKEY, KEY_LENGTH, Key);
		//delay_ms(10);
		NRF_LOG_INFO("Update KEY!!!!\r\n");
		NRF_LOG_FLUSH();
	/*
		int32_t *flash = Retrieving_A_Record(KEY_FILEID, KEY_RECKEY, KEY_LENGTH);
		if(flash)
		{
				hr_key = flash[0];
				hr_abnormal_key = flash[1];
				spo2_key = flash[2];
				bp_key = flash[3];
				hrv_key = flash[4];
				sdnn_key = flash[5];
				step_key = flash[6];
				calories_key = flash[7];
				NRF_LOG_INFO("flash[0]=%d, flash[1]=%d, flash[2]=%d, flash[3]=%d\r\n", flash[0], flash[1], flash[2], flash[3]);
				NRF_LOG_INFO("flash[4]=%d, flash[5]=%d, flash[6]=%d, flash[7]=%d\r\n", flash[4], flash[5], flash[6], flash[7]);
		}
		//delay_ms(20);
	*/
}


uint32_t get24bitUTC_data()
{
		uint32_t time = UTC_data;
		//NRF_LOG_INFO("UTC_data=%d, 24bits=%d\r\n", time, time%0x1000000);
		//bt_print("UTC_data=%d", time);
		return time%0x1000000;
}


void storeToFDS(FDS_T fdsID, int32_t* m_data, int length)
{
	int32_t UTC = get24bitUTC_data()* 0x100;
	//int32_t fds_data[513] = {0};
	static int fds_length_hrv = 0;
	//uint16_t fileID = 0, recKey = 0;
	static int hr = 1;
	static int calories = 1;
	int32_t* flash;
	static int32_t fds_data_hr[HR_LENGTH];
	static int32_t fds_data_calories[CAL_LENGTH];
	static uint16_t recKey_hr=0;
	static uint16_t recKey_calories=0;

	if(fdsID >= FDS_LAST)
		return;
		
	switch(fdsID)
	{
		case	FDS_HR:
			//24bits UTC + 8bits HR
			if(length == 1)
			{
				UTC 				+=	m_data[0];
				fds_data_hr[0] = UTC;
				//fds_length	= 	HR_LENGTH;
				//fileID			=		HR_FILEID;

				recKey_hr			=		hr_key++;
			
				flash = Retrieving_A_Record(HR_FILEID, recKey_hr, HR_LENGTH);
				if(!flash)
					Writing_A_Record(HR_FILEID, recKey_hr, fds_data_hr, HR_LENGTH);
				else
					Update_A_Record(HR_FILEID, recKey_hr, HR_LENGTH, fds_data_hr);
			}
			break;
		case	FDS_CALORIES:
			//24bits UTC + 0, 16bits Calories
			if(length == 1)
			{
				fds_data_calories[0]	=		UTC;
				fds_data_calories[1]	=		m_data[0];
				//fds_length	=		CAL_LENGTH;
				//fileID			=		CAL_FILEID;

				recKey_calories			=		calories_key++;
				
				flash = Retrieving_A_Record(CAL_FILEID, recKey_calories, CAL_LENGTH);
				if(!flash)
					Writing_A_Record(CAL_FILEID, recKey_calories, fds_data_calories, CAL_LENGTH);
				else
					Update_A_Record(CAL_FILEID, recKey_calories, CAL_LENGTH, fds_data_calories);
			}
			break;
		default:
			break;
	}

	SaveImportantData();
}

bool Update_A_Record(uint16_t fileID, uint16_t recKey, int length, int32_t* m_data)
{
		bool ret = false;
		uint32_t  ret1;
		fds_flash_record_t	flash_record;
		fds_record_desc_t		record_desc;
		fds_find_token_t		ftok;
		
		fds_record_t        record;
		// Set up record.
		record.file_id           	= fileID;
		record.key               	= recKey;
		record.data.p_data				= m_data;
		record.data.length_words  = length;
	
		memset(&ftok, 0x00, sizeof(fds_find_token_t));
	
		// Loop until all records with the given key and file ID have been found.
		while (fds_record_find(fileID, recKey, &record_desc, &ftok) == FDS_SUCCESS)
		{
				ret = true;
				if (fds_record_open(&record_desc, &flash_record) != FDS_SUCCESS)
				{
						// Handle error.
						NRF_LOG_INFO("fds_record_open() error\r\n");
				}

				// Access the record through the flash_record structure.
				int32_t* flash;
				bool notTheSame=false;
				if(flash_record.p_header->length_words==length)
				{
						flash = (int32_t*)flash_record.p_data;
						for(int i=0; i<length; ++i)
						{
								NRF_LOG_INFO("@@@@@@@@@@@@@@@@@flash_record_data==0x%X, %d, savedata=%d, length=%d\r\n", flash[i], flash[i], m_data[i], length);
								if(flash[i]!=m_data[i])
								notTheSame=true;
						}
						if( notTheSame )
						{
								NRF_LOG_INFO(" Update!!!!!\r\n");
								if( fds_record_update(&record_desc, &record) != FDS_SUCCESS)
								{
										NRF_LOG_INFO(" fds_record_update() error!!!!!\r\n");
								}
						}
				}

				// Close the record when done.
				if ( (ret1 = fds_record_close(&record_desc)) != FDS_SUCCESS)
				{
						// Handle error.
						NRF_LOG_INFO("fds_record_close() error %d\r\n", ret1);
				}
		}
	
		if(fds_gc() != FDS_SUCCESS)
		{
				NRF_LOG_INFO("fds_gc() error\r\n");
		}
		
		return ret;
}

ret_code_t Writing_A_Record(uint16_t fileID, uint16_t recKey, int32_t* m_data, int length)
{
		uint32_t ret;
		fds_record_t        record;
		fds_record_desc_t   record_desc;
		// Set up record.
		record.file_id           	= fileID;
		record.key               	= recKey;
		record.data.p_data				= m_data;
		record.data.length_words	= length;
    
		NRF_LOG_INFO("fds_record_writing...\r\n");
		ret = fds_record_write(&record_desc, &record);
		if (ret != FDS_SUCCESS)
		{
				NRF_LOG_INFO("fds_record_write() Error, %d\r\n", ret);
				//APP_ERROR_CHECK(ret);
				// Handle error.
		}
		
		return ret;
}

int32_t* Retrieving_A_Record(uint16_t fileID, uint16_t recKey, int length)
{
		fds_flash_record_t	flash_record;
		fds_record_desc_t		record_desc;
		fds_find_token_t		ftok;
		memset(&ftok, 0x00, sizeof(fds_find_token_t));
		uint32_t  ret1;
		int32_t* flash = NULL;

		// Loop until all records with the given key and file ID have been found.
		while (fds_record_find(fileID, recKey, &record_desc, &ftok) == FDS_SUCCESS)
		{
				if (fds_record_open(&record_desc, &flash_record) != FDS_SUCCESS)
				{
						// Handle error.
						NRF_LOG_INFO("fds_record_open() error\r\n");
				}

				// Access the record through the flash_record structure.
				if(flash_record.p_header->length_words==length)
				{
						flash = (int32_t*)flash_record.p_data;
					#ifdef __OPENLOG
						for(int i=0; i<length; ++i)
						{
							NRF_LOG_INFO("@@@@@@@@@@@@@@@@@flash_record_data==0x%X, %d\r\n", flash[i],flash[i]);
						}
					#endif
				}

				// Close the record when done.
				if ( (ret1 = fds_record_close(&record_desc)) != FDS_SUCCESS)
				{
						// Handle error.
						NRF_LOG_INFO("fds_record_close() error %d\r\n", ret1);
				}
		}

		if(fds_gc() != FDS_SUCCESS)
		{
				NRF_LOG_INFO("fds_gc() error\r\n");
		}

		return flash;
}

int32_t Deleting_A_Record(uint16_t fileID, uint16_t recKey)
{
		uint32_t ret;
		fds_record_desc_t		record_desc;
		fds_find_token_t		ftok;
		memset(&ftok, 0x00, sizeof(fds_find_token_t));

		// Loop until all records with the given key and file ID have been found.
		while (fds_record_find(fileID, recKey, &record_desc, &ftok) == FDS_SUCCESS)
		{
				/* Assume a descriptor returned by a call to fds_record_write() or fds_record_find(),
					 as shown in the previous example. */
				ret_code_t ret = fds_record_delete(&record_desc);
				if (ret != FDS_SUCCESS)
				{
					// Error.
					NRF_LOG_INFO("fds_record_delete() Error!\r\n");
				}
		}

		if(fds_gc() != FDS_SUCCESS)
		{
				NRF_LOG_INFO("fds_gc() error\r\n");
		}

		return ret;
}
