#ifndef __FLASH_DATA_STORAGE_H__
#define __FLASH_DATA_STORAGE_H__
// c
#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include "fds.h"

typedef enum
{
	FDS_HR,
	FDS_CALORIES,
	//add new feature before FDS_LAST
	FDS_LAST,
} FDS_T;

//for test calories, need age, gender(MALE or FEMALE), weight(kg)
#define CALORIES_RECKEY			0x2000
#define CALORIES_FILEID			0x2000
#define CALORIES_LENGTH			0x04
//for store normal HR to FDS
#define HR_FILEID						0x4000
#define	HR_LENGTH						0x01		//word length
//for store calories to FDS
#define CAL_FILEID					0xB000
#define	CAL_LENGTH					0x02		//word length
//for store each reckey to FDS
#define KEY_RECKEY					0xC000
#define KEY_FILEID					0xC000
#define KEY_LENGTH					0x02


ret_code_t Writing_A_Record(uint16_t fileID, uint16_t recKey, int32_t* m_data, int length);
bool Update_A_Record(uint16_t fileID, uint16_t recKey, int length, int32_t* m_data);
int32_t Deleting_A_Record(uint16_t fileID, uint16_t recKey);
int32_t* Retrieving_A_Record(uint16_t fileID, uint16_t recKey, int length);
void storeToFDS(FDS_T fdsID, int32_t* m_data, int length);
int get_latest_calories(void);
void SaveImportantData(void);
#endif
